Index: /trunk/admin/user_list.php
===================================================================
--- /trunk/admin/user_list.php	(revision 5020)
+++ /trunk/admin/user_list.php	(revision 5021)
@@ -169,8 +169,8 @@
 
 $page['order_by_items'] = array(
-  'id' => l10n('registration_date'),
+  'id' => l10n('registration date'),
   'username' => l10n('Username'),
   'level' => l10n('Privacy level'),
-  'language' => l10n('language'),
+  'Language' => l10n('Language'),
   );
 
@@ -192,17 +192,17 @@
     if(empty($_POST['password']))
     {
-      array_push($page['errors'], l10n('Password is missing'));
+      array_push($page['errors'], l10n('Password is missing. Please enter the password.'));
     }
     else if(empty($_POST['password_conf']))
     {
-      array_push($page['errors'], l10n('Password confirmation is missing'));
+      array_push($page['errors'], l10n('Password confirmation is missing. Please confirm the chosen password.'));
     }
     else if(empty($_POST['email']))
     {
-      array_push($page['errors'], l10n('Email address is missing'));
+      array_push($page['errors'], l10n('Email address is missing. Please specify an email address.'));
     }
     else if ($_POST['password'] != $_POST['password_conf'])
     {
-      array_push($page['errors'], l10n('Password confirmation error'));
+      array_push($page['errors'], l10n('Password confirmation error.'));
     }
     else
@@ -216,5 +216,5 @@
           $page['infos'],
           sprintf(
-            l10n('user "%s" added'),
+            l10n('user \"%s\" added'),
             $_POST['login']
           )
@@ -236,5 +236,5 @@
         $page['infos'],
         sprintf(
-          l10n('user "%s" added'),
+          l10n('user \"%s\" added'),
           $_POST['login']
           )
@@ -694,5 +694,5 @@
   $properties[] =
     (isset($local_user['enabled_high']) and ($local_user['enabled_high'] == 'true'))
-        ? l10n('is_high_enabled') : l10n('is_high_disabled');
+        ? l10n('') : l10n('');
 
   $template->append(
@@ -705,10 +705,10 @@
       'USERNAME' => stripslashes($local_user['username'])
         .($local_user['id'] == $conf['guest_id']
-          ? '<br>['.l10n('is_the_guest').']' : '')
+          ? '<br>['.l10n('guest').']' : '')
         .($local_user['id'] == $conf['default_user_id']
-          ? '<br>['.l10n('is_the_default').']' : ''),
+          ? '<br>['.l10n('default values').']' : ''),
       'STATUS' => l10n('user_status_'.
         $local_user['status']).(($local_user['adviser'] == 'true')
-        ? '<br>['.l10n('adviser').']' : ''),
+        ? '<br>['.l10n('Adviser').']' : ''),
       'EMAIL' => get_email_address_as_display_text($local_user['email']),
       'GROUPS' => $groups_string,
Index: /trunk/admin/user_perm.php
===================================================================
--- /trunk/admin/user_perm.php	(revision 5020)
+++ /trunk/admin/user_perm.php	(revision 5021)
@@ -127,10 +127,10 @@
     'TITLE' =>
       sprintf(
-        l10n('Manage permissions for user "%s"'),
+        l10n('Manage permissions for user \"%s\"'),
         get_username($page['user']
           )
         ),
-    'L_CAT_OPTIONS_TRUE'=>l10n('authorized'),
-    'L_CAT_OPTIONS_FALSE'=>l10n('forbidden'),
+    'L_CAT_OPTIONS_TRUE'=>l10n('Authorized'),
+    'L_CAT_OPTIONS_FALSE'=>l10n('Forbidden'),
 
     'F_ACTION' =>
Index: /trunk/identification.php
===================================================================
--- /trunk/identification.php	(revision 5020)
+++ /trunk/identification.php	(revision 5021)
@@ -40,5 +40,5 @@
   if ( is_a_guest() )
   {
-    array_push($errors, l10n('access_forbiden'));
+    array_push($errors, l10n('You are not authorized to access the requested page'));
   }
 }
@@ -63,5 +63,5 @@
     else
     {
-      array_push( $errors, l10n('invalid_pwd') );
+      array_push( $errors, l10n('Invalid password!') );
     }
   }
@@ -72,5 +72,5 @@
 // Start output of page
 //
-$title = l10n('identification');
+$title = l10n('Identification');
 $page['body_id'] = 'theIdentificationPage';
 include(PHPWG_ROOT_PATH.'include/page_header.php');
Index: /trunk/include/calendar_base.class.php
===================================================================
--- /trunk/include/calendar_base.class.php	(revision 5020)
+++ /trunk/include/calendar_base.class.php	(revision 5021)
@@ -96,5 +96,5 @@
     elseif ('any' === $date_component )
     {
-      $label = l10n('calendar_any');
+      $label = l10n('All');
     }
     return $label;
@@ -193,5 +193,5 @@
           );
       $nav_bar_datas[]=array(
-        'LABEL' => l10n('calendar_any'),
+        'LABEL' => l10n('All'),
         'URL' => $url
       );
Index: /trunk/include/common.inc.php
===================================================================
--- /trunk/include/common.inc.php	(revision 5020)
+++ /trunk/include/common.inc.php	(revision 5021)
@@ -174,10 +174,10 @@
     $user['internal_status']['guest_must_be_guest'] === true)
 {
-  $header_msgs[] = l10n('guest_must_be_guest');
+  $header_msgs[] = l10n('Bad status for user "guest", using default status. Please notify the webmaster.');
 }
 
 if ($conf['gallery_locked'])
 {
-  $header_msgs[] = l10n('gallery_locked_message');
+  $header_msgs[] = l10n('The gallery is locked for maintenance. Please, come back later.');
 
   if ( script_basename() != 'identification' and !is_admin() )
@@ -186,5 +186,5 @@
     @header('Retry-After: 900');
     header('Content-Type: text/html; charset='.get_pwg_charset());
-    echo '<a href="'.get_absolute_root_url(false).'identification.php">'.l10n('gallery_locked_message').'</a>';
+    echo '<a href="'.get_absolute_root_url(false).'identification.php">'.l10n('The gallery is locked for maintenance. Please, come back later.').'</a>';
     echo str_repeat( ' ', 512); //IE6 doesn't error output if below a size
     exit();
@@ -204,5 +204,5 @@
 if (is_adviser())
 {
-  $header_msgs[] = l10n('adviser_mode_enabled');
+  $header_msgs[] = l10n('Adviser mode enabled');
 }
 
Index: /trunk/include/functions.inc.php
===================================================================
--- /trunk/include/functions.inc.php	(revision 5020)
+++ /trunk/include/functions.inc.php	(revision 5021)
@@ -31,4 +31,5 @@
 include_once( PHPWG_ROOT_PATH .'include/functions_url.inc.php' );
 include_once( PHPWG_ROOT_PATH .'include/functions_plugins.inc.php' );
+include_once( PHPWG_ROOT_PATH .'include/php-gettext/gettext.inc.php' );
 
 //----------------------------------------------------------- generic functions
@@ -40,5 +41,5 @@
 			 );
   if (!empty($fields))
-  {
+  { 
     $fields = ','.$fields;
   }
@@ -174,5 +175,5 @@
     if ($mkd==false)
     {
-      !($flags&MKGETDIR_DIE_ON_ERROR) or fatal_error( "$dir ".l10n('no_write_access'));
+      !($flags&MKGETDIR_DIE_ON_ERROR) or fatal_error( "$dir ".l10n('no write access'));
       return false;
     }
@@ -190,5 +191,5 @@
   if ( !is_writable($dir) )
   {
-    !($flags&MKGETDIR_DIE_ON_ERROR) or fatal_error( "$dir ".l10n('no_write_access'));
+    !($flags&MKGETDIR_DIE_ON_ERROR) or fatal_error( "$dir ".l10n('no write access'));
     return false;
   }
@@ -214,5 +215,5 @@
   {
     array_push($errors,
-          '['.$dirname.'] : '.l10n('no_write_access'));
+          '['.$dirname.'] : '.l10n('no write access'));
     return false;
   }
@@ -621,5 +622,5 @@
   if (empty($msg))
   {
-    $msg = nl2br(l10n('redirect_msg'));
+    $msg = nl2br(l10n('Redirection...'));
   }
 
@@ -867,14 +868,26 @@
  * @return string
  */
-function l10n($key)
-{
-  global $lang, $conf;
-
-  if ($conf['debug_l10n'] and !isset($lang[$key]) and !empty($key))
-  {
-    trigger_error('[l10n] language key "'.$key.'" is not defined', E_USER_WARNING);
-  }
-
-  return isset($lang[$key]) ? $lang[$key] : $key;
+function l10n($key, $textdomain='messages')
+{
+  global $user;
+
+  if (empty($user['language']))
+  {
+    $locale = $GLOBALS['language'];
+  } 
+  else 
+  {
+    $locale = $user['language'];
+  }
+
+  T_setlocale(LC_ALL, $locale.'.UTF-8');
+
+  // Specify location of translation tables
+  T_bindtextdomain($textdomain, "./language");
+
+  // Choose domain
+  T_textdomain($textdomain);
+  
+  return T_gettext($key);
 }
 
@@ -888,16 +901,33 @@
  * @return string
  */
-function l10n_dec($singular_fmt_key, $plural_fmt_key, $decimal)
-{
-  global $lang_info;
-
-  return
-    sprintf(
-      l10n((
-        (($decimal > 1) or ($decimal == 0 and $lang_info['zero_plural']))
-          ? $plural_fmt_key
-          : $singular_fmt_key
-        )), $decimal);
-}
+function l10n_dec($singular_fmt_key, $plural_fmt_key, 
+		  $decimal, $textdomain='messages')
+{
+  global $user;
+
+  if (empty($user['language']))
+  {
+    $locale = $GLOBALS['language'];
+  } 
+  else 
+  {
+    $locale = $user['language'];
+  }
+
+  T_setlocale(LC_ALL, $locale.'.UTF-8');
+
+  // Specify location of translation tables
+  T_bindtextdomain($textdomain, "./language");
+
+  // Choose domain
+  T_textdomain($textdomain);
+
+  return sprintf(T_ngettext($singular_fmt_key, 
+			    $plural_fmt_key, 
+			    $decimal),
+		 $decimal
+		 );
+}
+
 /*
  * returns a single element to use with l10n_args
@@ -1436,5 +1466,5 @@
   {
     $cache['get_icon']['title'] = sprintf(
-      l10n('elements posted during the last %d days'),
+      l10n('images posted during the last %d days'),
       $user['recent_period']
       );
Index: /trunk/include/functions_category.inc.php
===================================================================
--- /trunk/include/functions_category.inc.php	(revision 5020)
+++ /trunk/include/functions_category.inc.php	(revision 5021)
@@ -287,7 +287,7 @@
   return trigger_event('get_category_preferred_image_orders',
     array(
-    array(l10n('default_sort'), '', true),
+    array(l10n('Default'), '', true),
     array(l10n('Average rate'), 'average_rate DESC', $conf['rate']),
-    array(l10n('most_visited_cat'), 'hit DESC', true),
+    array(l10n('Most visited'), 'hit DESC', true),
     array(l10n('Creation date'), 'date_creation DESC', true),
     array(l10n('Post date'), 'date_available DESC', true),
@@ -298,5 +298,5 @@
       ('categories' == @$page['section'] and !isset($page['flat']) and !isset($page['chronology_field']) )
       ),
-    array( l10n('permissions'), 'level DESC', is_admin() )
+    array( l10n('Permissions'), 'level DESC', is_admin() )
     ));
 }
@@ -480,5 +480,5 @@
       if (! $short_message)
       {
-        $display_text.= ' '.l10n('images_available_cpl');
+        $display_text.= ' '.l10n('in this category');
       }
     }
Index: /trunk/include/functions_comment.inc.php
===================================================================
--- /trunk/include/functions_comment.inc.php	(revision 5020)
+++ /trunk/include/functions_comment.inc.php	(revision 5021)
@@ -104,5 +104,5 @@
       if ( $row['user_exists'] == 1 )
       {
-        array_push($infos, l10n('comment_user_exists') );
+        array_push($infos, l10n('This login is already used by another user') );
         $comment_action='reject';
       }
@@ -141,5 +141,5 @@
     if ( pwg_db_num_rows( pwg_query( $query ) ) > 0 )
     {
-      array_push( $infos, l10n('comment_anti-flood') );
+      array_push( $infos, l10n('Anti-flood system : please wait for a moment before trying to post another comment') );
       $comment_action='reject';
     }
@@ -269,5 +269,5 @@
     if ( pwg_db_num_rows( pwg_query( $query ) ) > 0 )
     {
-      //?? array_push( $infos, l10n('comment_anti-flood') );
+      //?? array_push( $infos, l10n('Anti-flood system : please wait for a moment before trying to post another comment') );
       $comment_action='reject';
     }
Index: /trunk/include/functions_html.inc.php
===================================================================
--- /trunk/include/functions_html.inc.php	(revision 5020)
+++ /trunk/include/functions_html.inc.php	(revision 5021)
@@ -293,7 +293,7 @@
   {
     echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">';
-    echo '<div style="text-align:center;">'.l10n('access_forbiden').'<br>';
-    echo '<a href="'.get_root_url().'identification.php">'.l10n('identification').'</a>&nbsp;';
-    echo '<a href="'.make_index_url().'">'.l10n('home').'</a></div>';
+    echo '<div style="text-align:center;">'.l10n('You are not authorized to access the requested page').'<br>';
+    echo '<a href="'.get_root_url().'Identification.php">'.l10n('Identification').'</a>&nbsp;';
+    echo '<a href="'.make_index_url().'">'.l10n('Home').'</a></div>';
     echo str_repeat( ' ', 512); //IE6 doesn't error output if below a size
     exit();
@@ -400,5 +400,5 @@
 {
   global $page;
-  $title = count($page['tags']) > 1 ? l10n('Tags') : l10n('Tag');
+  $title = count($page['tags']) > 1 ? l10n('Tag') : l10n('Tag');
   $title.= ' ';
 
@@ -415,5 +415,5 @@
         )
       .'" title="'
-      .l10n('See elements linked to this tag only')
+      .l10n('See images linked to this tag only')
       .'">'
       .$page['tags'][$i]['name']
@@ -432,5 +432,5 @@
           )
         .'" style="border:none;" title="'
-        .l10n('remove this tag')
+        .l10n('remove this tag from the list')
         .'"><img src="'
         .get_root_url().get_themeconf('icon_dir').'/remove_s.png'
Index: /trunk/include/functions_mail.inc.php
===================================================================
--- /trunk/include/functions_mail.inc.php	(revision 5020)
+++ /trunk/include/functions_mail.inc.php	(revision 5021)
@@ -647,5 +647,5 @@
           'PHPWG_URL' => PHPWG_URL,
 
-          'TITLE_MAIL' => urlencode(l10n('title_send_mail')),
+          'TITLE_MAIL' => urlencode(l10n('A comment on your site')),
           'MAIL' => get_webmaster_mail_address()
           ));
Index: /trunk/include/functions_notification.inc.php
===================================================================
--- /trunk/include/functions_notification.inc.php	(revision 5020)
+++ /trunk/include/functions_notification.inc.php	(revision 5021)
@@ -530,5 +530,5 @@
         .' ('
         .'<a href="'.make_index_url(array('section'=>'recent_pics')).'">'
-          .l10n('recent_pics_cat').'</a>'
+          .l10n('Recent pictures').'</a>'
         .')'
         .'</li><br>';
Index: /trunk/include/functions_user.inc.php
===================================================================
--- /trunk/include/functions_user.inc.php	(revision 5020)
+++ /trunk/include/functions_user.inc.php	(revision 5021)
@@ -48,5 +48,5 @@
   if ( !preg_match( $regex, $mail_address ) )
   {
-    return l10n('reg_err_mail_address');
+    return l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)');
   }
 
@@ -62,5 +62,5 @@
     if ($count != 0)
     {
-      return l10n('reg_err_mail_address_dbl');
+      return l10n('a user use already this mail address');
     }
   }
@@ -87,5 +87,5 @@
     if ($count > 0)
     {
-      return l10n('reg_err_login5');
+      return l10n('this login is already used');
     }
   }
@@ -99,17 +99,17 @@
   if ($login == '')
   {
-    array_push($errors, l10n('reg_err_login1'));
+    array_push($errors, l10n('Please, enter a login'));
   }
   if (preg_match('/^.* $/', $login))
   {
-    array_push($errors, l10n('reg_err_login2'));
+    array_push($errors, l10n('login mustn\'t end with a space character'));
   }
   if (preg_match('/^ .*$/', $login))
   {
-    array_push($errors, l10n('reg_err_login3'));
+    array_push($errors, l10n('login mustn\'t start with a space character'));
   }
   if (get_userid($login))
   {
-    array_push($errors, l10n('reg_err_login5'));
+    array_push($errors, l10n('this login is already used'));
   }
   $mail_error = validate_mail_address(null, $mail_address);
Index: /trunk/include/menubar.inc.php
===================================================================
--- /trunk/include/menubar.inc.php	(revision 5020)
+++ /trunk/include/menubar.inc.php	(revision 5021)
@@ -149,6 +149,6 @@
         array(
           'URL' => make_index_url(array('section' => 'favorites')),
-          'TITLE' => l10n('favorite_cat_hint'),
-          'NAME' => l10n('favorite_cat')
+          'TITLE' => l10n('display my favorites pictures'),
+          'NAME' => l10n('My favorites')
           );
     }
@@ -157,6 +157,6 @@
       array(
         'URL' => make_index_url(array('section' => 'most_visited')),
-        'TITLE' => l10n('most_visited_cat_hint'),
-        'NAME' => l10n('most_visited_cat')
+        'TITLE' => l10n('display most visited pictures'),
+        'NAME' => l10n('Most visited')
       );
 
@@ -166,6 +166,6 @@
         array(
           'URL' => make_index_url(array('section' => 'best_rated')),
-          'TITLE' => l10n('best_rated_cat_hint'),
-          'NAME' => l10n('best_rated_cat')
+          'TITLE' => l10n('display best rated items'),
+          'NAME' => l10n('Best rated')
         );
     }
@@ -174,6 +174,6 @@
       array(
         'URL' => get_root_url().'random.php',
-        'TITLE' => l10n('random_cat_hint'),
-        'NAME' => l10n('random_cat'),
+        'TITLE' => l10n('display a set of random pictures'),
+        'NAME' => l10n('Random pictures'),
         'REL'=> 'rel="nofollow"'
       );
@@ -182,6 +182,6 @@
       array(
         'URL' => make_index_url(array('section' => 'recent_pics')),
-        'TITLE' => l10n('recent_pics_cat_hint'),
-        'NAME' => l10n('recent_pics_cat'),
+        'TITLE' => l10n('display most recent pictures'),
+        'NAME' => l10n('Recent pictures'),
       );
 
@@ -189,6 +189,6 @@
       array(
         'URL' => make_index_url(array('section' => 'recent_cats')),
-        'TITLE' => l10n('recent_cats_cat_hint'),
-        'NAME' => l10n('recent_cats_cat'),
+        'TITLE' => l10n('display recently updated categories'),
+        'NAME' => l10n('Recent categories'),
       );
 
@@ -205,6 +205,6 @@
             )
           ),
-        'TITLE' => l10n('calendar_hint'),
-        'NAME' => l10n('calendar'),
+        'TITLE' => l10n('display each day with pictures, month per month'),
+        'NAME' => l10n('Calendar'),
         'REL'=> 'rel="nofollow"'
       );
@@ -231,5 +231,5 @@
     $block->data['search'] =
       array(
-        'TITLE'=>l10n('hint_search'),
+        'TITLE'=>l10n('search'),
         'NAME'=>l10n('Search'),
         'URL'=> get_root_url().'search.php',
@@ -240,6 +240,6 @@
     $block->data['comments'] =
       array(
-        'TITLE'=>l10n('hint_comments'),
-        'NAME'=>l10n('comments'),
+        'TITLE'=>l10n('See last users comments'),
+        'NAME'=>l10n('Comments'),
         'URL'=> get_root_url().'comments.php',
       );
@@ -248,5 +248,5 @@
     $block->data['about'] =
       array(
-        'TITLE'     => l10n('about_page_title'),
+        'TITLE'     => l10n('About Piwigo'),
         'NAME'      => l10n('About'),
         'URL' => get_root_url().'about.php',
